#include <pic16f886.h>
#include <xc.h>
#include "user_define.h"
#include "eeprom.h"

extern unsigned int	mhz_no;
extern unsigned char volume;
//extern unsigned char width;

/*----------EEPROM----------*/
unsigned char E2promRead(unsigned char adr)
{
	EEADR=adr;
	RD=1;
	return(EEDATA);
}

void E2promWrite(unsigned char adr,unsigned char data)
{
	EEADR=adr;
	EEDATA=data;
	
	WREN=1;
	EECON2=0x55;
	EECON2=0xaa;
	
	WR=1;
	while(EEIF==0)
	{
		NOP();
	}
	EEIF=0;
	WREN=0;
}

void    eeprom_init(void)
{
 	E2promWrite(0x00,0xa5);   
    eeprom_write_direct();
    
}

void	eeprom_check(void)
{
	if(E2promRead(0x00)==0xa5){
		mhz_no=(unsigned int)E2promRead(0x0b)*256+(unsigned int)E2promRead(0x0a);
        volume=E2promRead(0x0c);
        //width=E2promRead(0x0d);
	}
	else{
		eeprom_init();
	}
}

void	eeprom_write_direct(void)
{
		E2promWrite(0x0b,(unsigned char)(mhz_no >> 8));
        E2promWrite(0x0a,(unsigned char)(mhz_no & 0xff));
		E2promWrite(0x0c,volume);
        //E2promWrite(0x0d,width);
}